unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, GLU, GL;

type
  TForm1 = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    DC:HDC;
    hrc:HGLRC;
    X,Y,Z:real;
    RX,RY,RZ:real;
    procedure PixelFormat;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormPaint(Sender: TObject);
var
 ps:TPaintStruct;
begin
 BeginPaint(Handle,ps);
 glClearColor(1,0.5,0.5,1);
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

 glPushMatrix;
  glRotated(45,1,0,0);
  glTranslatef(X,Y,Z);

  glRotated(RX,1,0,0);
  glRotated(RY,0,1,0);
  glRotated(RZ,0,0,1);

  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LESS);

  glCallList(1);
  glTranslatef(2,2,0);
  glCallList(1);
  glTranslatef(-4,-4,2);
  glCallList(1);
 glPopMatrix;

 glFlush();
 swapBuffers(dc);
 EndPaint(Handle,ps);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();

 if width <= height then
  glOrtho (-2, 2, -2*height/width, 2*height/width, 10.0, -10.0)
 else
  glOrtho (-2*width/height, 2*width/height, -2, 2, 10.0, -10.0);

 glViewport(0, 0, width, height);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 wglMakeCurrent(0,0);
 wglDeleteContext(hrc);
 ReleaseDC(handle,DC);
end;

procedure TForm1.PixelFormat;
var
 nPixelFormat:Integer;
 pfd:TPixelFormatDescriptor;
begin
 FillChar(pfd,Sizeof(pfd),0);

 pfd.nSize:=sizeof(pfd);
 pfd.nVersion:=1;
 pfd.dwFlags:=PFD_DOUBLEBUFFER+PFD_SUPPORT_OPENGL+PFD_DRAW_TO_WINDOW;
 pfd.iPixelType:=PFD_TYPE_RGBA;
 pfd.cColorBits:=24;
 pfd.cAlphaBits:=64;
 pfd.cAccumBits:=64;
 pfd.cDepthBits:=32;
 pfd.cStencilBits:=64;
 pfd.iLayerType:=PFD_MAIN_PLANE;

 nPixelFormat:=ChoosePixelFormat(DC,@pfd);
 if nPixelFormat<>0 then
  SetPixelFormat(DC,nPixelFormat,@pfd);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 DC:=GetDC(Handle);
 PixelFormat;
 hrc:=wglCreateContext(DC);
 wglMakeCurrent(DC,hrc);

 X:=0;Y:=0;Z:=0;
 RX:=0;RY:=0;RZ:=0;

 glNewList(1,GL_COMPILE);
  glColor3f (0.0, 1.0, 0.0);
  glBegin(GL_QUAD_STRIP);
   glVertex3f(1.25,1.25,1);
   glVertex3f(1.25,-1.0,1);
   glVertex3f(-1,1.25,0);
   glVertex3f(-1,-1.0,0);
  glEnd;

  glColor3f (1.0, 1.0, 0.0);
  glBegin(GL_QUAD_STRIP);
   glVertex3f(1.0,1.0,0);
   glVertex3f(1.0,-1.25,0);
   glVertex3f(-1.25,1.0,1);
   glVertex3f(-1.25,-1.25,1);
  glEnd;
 glEndList;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key =VK_RIGHT then
  X:=X+0.1;
 if Key =VK_LEFT then
  X:=X-0.1;
 if Key =VK_UP then
  Y:=Y+0.1;
 if Key =VK_DOWN then
  Y:=Y-0.1;

 if Key =VK_INSERT then
  RY:=RY-2;
 if Key =VK_DELETE then
  RY:=RY+2;

 if Key =VK_HOME then
  RX:=RX-2;
 if Key =VK_END then
  RX:=RX+2;

 FormPaint(nil);


end;

end.


